function Configuration_InitFcn( toplevel_model, current_block )

% Configure the model callbacks (PreLoadFcn and PostLoadFcn)
Configure_model_callbacks(toplevel_model);

% Model workspace
hws = get_param(toplevel_model, 'modelworkspace');

% Set CTRLPERIOD in model workspace
if strcmp(get_param(current_block, 'sampling_conf'), 'Standard')
    ratio = 2*str2num(get_param(current_block, 'POSTSCALER'));
    ctrlphase = str2num(get_param(current_block, 'PHASE'));
else
    ratio = 2*str2num(get_param(current_block, 'interrupt_pstsclr_2'));
    ctrlphase = str2num(get_param(current_block, 'interrupt_phase_2'));
end
if ratio == 0
    ratio = 1;
end
clkperiod = 1.0/evalin('base', get_param(current_block, 'clk0_freq'));
if strcmp('Automated Code Generation',get_param(current_block,'SLMODE'))
    hws.assignin('CTRLPERIOD', ratio*clkperiod);
else
    hws.assignin('CTRLPERIOD', [ratio*clkperiod, clkperiod*ctrlphase+1e-9]); % Added 1 ns for solver stability
end

% Set computation time in model workspace
hws.assignin('global_comp_time', str2num(get_param(current_block, 'computation_time')));

hws.assignin('global_CLK_number',0);
hws.assignin('global_INT_number',0);

set_mailboxes_id(toplevel_model);
set_svm_id(toplevel_model);

end
